Historical Bulk Traffic Estimation


This endpoint will provide you with historical monthly traffic volumes for up to 1,000 domains collected within the specified time range through October 2020. If you do not specify the range, data will be returned for the previous 12 months. Along with organic search traffic estimations, you will also get separate values for paid search, featured snippet, and local pack results.

Traffic volume is calculated as the product of CTR (click-through rate) and search volume values of all keywords the domain ranks for in a relevant category of search results (organic, paid, featured snippet, or local pack). You can learn more about how we calculate this metric in this help center article.

Historical data is available from 2020-10-01.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task. The maximum number of calls that can be sent simultaneously is limited to 30.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
targetsarray

target domains and subdomains
required field
you can specify domains and subdomains in this field;
domains and subdomains should be specified without https:// and www.;
you can set up to 1000 domains or subdomains

location_namestring

full name of the location
if you use this field, you don't have to specify location_code
you can receive the list of available locations with their location_name by making a separate request to the
https://api.dataforseo.com/v3/dataforseo_labs/locations_and_languages
ignore this field to get the results for all available locations
example:
United Kingdom

location_codeinteger

location code
if you use this field, you don't have to specify location_name
you can receive the list of available locations with their location_code by making a separate request to the
https://api.dataforseo.com/v3/dataforseo_labs/locations_and_languages
ignore this field to get the results for all available locations
example:
2840

language_namestring

full name of the language
if you use this field, you don’t need to specify language_code
you can receive the list of available languages with their language_name by making a separate request to the
https://api.dataforseo.com/v3/dataforseo_labs/locations_and_languages
ignore this field to get the results for all available languages
example:
English

language_codestring

language code
if you use this field, you don’t need to specify language_name
you can receive the list of available languages with their language_code by making a separate request to the
https://api.dataforseo.com/v3/dataforseo_labs/locations_and_languages
ignore this field to get the results for all available languages
example:
en

date_fromstring

starting date of the time range
optional field
if you don't specify this field, the data will be provided for the previous 12 months
minimal possible value: 2020-10-01
date format: "yyyy-mm-dd"

date_tostring

ending date of the time range
optional field
if you don't specify this field, the today's date will be used by default;
date format: "yyyy-mm-dd"
example:
"2021-04-01"

ignore_synonymsboolean

ignore highly similar keywords
optional field
if set to_true only core keywords will be returned, all highly similar keywords will be excluded;
default value: falsen

item_typesarray

display results by item type
optional field
indicates the type of search results included in the response;
Note: if the item_types array contains item types that are different from organic, the results will be ordered by the first item type in the array;
possible values:
["organic", "paid", "featured_snippet", "local_pack"]
default value:
["organic", "paid"]

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        se_typestring

search engine type

        location_codeinteger

location code in a POST array
if there is no data, then the value is null

        language_codestring

language code in a POST array
if there is no data, then the value is null

        total_countinteger

total amount of results in our database relevant to your request

        items_countinteger

the number of results returned in the items array

        itemsarray

array of items with relevant traffic estimation data

            se_typestring

search engine type

            targetstring

target domain in a POST array

            metricsobject

traffic data relevant to the specified domain

                organicarray

traffic data from organic search

                    yearinteger

year for which the data is provided

                    monthinteger

month for which the data is provided

                    etvfloat

estimated traffic volume
estimated organic monthly traffic to the domain
calculated as the product of CTR (click-through-rate) and search volume values of all keywords the domain ranks for
learn more about how the metric is calculated in this help center article

                    countinteger

total count of organic SERPs that contain the domain

                paidarray

traffic data from paid search

                    yearinteger

year for which the data is provided

                    monthinteger

month for which the data is provided

                    etvfloat

estimated traffic volume
estimated paid monthly traffic to the domain
calculated as the product of CTR (click-through-rate) and search volume values of all keywords the domain ranks for
learn more about how the metric is calculated in this help center article

                    countinteger

total count of paid SERPs that contain the domain

                featured_snippetarray

traffic data from the featured snippet results in Google SERP

                    yearinteger

year for which the data is provided

                    monthinteger

month for which the data is provided

                    etvfloat

estimated traffic volume
estimated paid monthly traffic to the domain
calculated as the product of CTR (click-through-rate) and search volume values of all keywords in the category that the domain ranks for
learn more about how the metric is calculated in this help center article

                    countinteger

total count of featured snippet items that contain the domain

                local_packarray

traffic data from the local pack results in SERP

                    yearinteger

year for which the data is provided

                    monthinteger

month for which the data is provided

                    etvfloat

estimated traffic volume
estimated paid monthly traffic to the domain
calculated as the product of CTR (click-through-rate) and search volume values of all keywords in the category that the domain ranks for
learn more about how the metric is calculated in this help center article

                    countinteger

total count of local pack items that contain the domain


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/dataforseo_labs/google/historical_bulk_traffic_estimation/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "targets": [
            "dataforseo.com",
            "cnn.com",
            "forbes.com"
        ],
        "location_code": 2840,
        "language_code": "en",
        "date_from": "2021-01-01",
        "date_to": "2021-03-29",
        "item_types": [
            "organic",
            "paid"
        ]
    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');

$post_array = array();
// simple way to set a task
$post_array[] = array(
   "targets" => [
      "dataforseo.com",
      "cnn.com",
      "forbes.com"
   ],
   "language_name" => "English",
   "location_code" => 2840,
   "date_from": => "2021-01-01",
   "date_to": => "2021-03-29",
   "item_types" => [
      "organic",
      "paid"
   ]
);
try {
   // POST /v3/dataforseo_labs/google/historical_bulk_traffic_estimation/live
   $result = $client->post('/v3/dataforseo_labs/google/historical_bulk_traffic_estimation/live', $post_array);
   print_r($result);
   // do something with post result
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({
  "targets": [
    "dataforseo.com",
    "cnn.com",
    "forbes.com"
  ],
  "language_name": "English",
  "location_code": 2840,
  "date_from": "2021-01-01",
  "date_to": "2021-03-29",
  "item_types": [
    "organic",
    "paid"
  ]
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/dataforseo_labs/google/historical_bulk_traffic_estimation/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    targets=[
        "dataforseo.com",
        "cnn.com",
        "forbes.com"
    ],
    location_name="United States",
    language_name="English",
    date_from= "2021-01-01",
    date_to= "2021-03-29",
    item_types=[
        "organic",
        "paid"
    ]
)
# POST /v3/dataforseo_labs/google/historical_bulk_traffic_estimation/live
response = client.post("/v3/dataforseo_labs/google/historical_bulk_traffic_estimation/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task dataforseo_labs_google_bulk_traffic_estimation_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                targets = new[]
                {
                    "dataforseo.com",
                    "cnn.com",
                    "forbes.com"
                },
                location_name = "United States",
                language_name = "English",
                date_from = "2021-01-01",
                date_to = "2021-03-29",
                item_types = new[]
                {
                    "organic",
                    "paid"
                }
            });
            // POST /v3/dataforseo_labs/google/historical_bulk_traffic_estimation/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/dataforseo_labs/google/historical_bulk_traffic_estimation/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20230705",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.1397 sec.",
  "cost": 0.103,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "07261403-6223-0563-0000-3d0a5c66407e",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "0.0678 sec.",
      "cost": 0.103,
      "result_count": 1,
      "path": [
        "v3",
        "dataforseo_labs",
        "google",
        "historical_bulk_traffic_estimation",
        "live"
      ],
      "data": {
        "api": "dataforseo_labs",
        "function": "historical_bulk_traffic_estimation",
        "se_type": "google",
        "targets": [
          "dataforseo.com",
          "cnn.com",
          "forbes.com"
        ],
        "location_code": 2840,
        "language_code": "en",
        "date_from": "2021-01-01",
        "date_to": "2021-03-29",
        "item_types": [
          "organic",
          "paid"
        ]
      },
      "result": [
        {
          "se_type": "google",
          "location_code": 2840,
          "language_code": "en",
          "total_count": 3,
          "items_count": 3,
          "items": [
            {
              "se_type": "google",
              "target": "cnn.com",
              "metrics": {
                "organic": [
                  {
                    "year": 2021,
                    "month": 3,
                    "etv": 224412747.905034,
                    "count": 16031288
                  },
                  {
                    "year": 2021,
                    "month": 2,
                    "etv": 226712953.25628597,
                    "count": 15936794
                  },
                  {
                    "year": 2021,
                    "month": 1,
                    "etv": 97614973.29717998,
                    "count": 9812595
                  }
                ],
                "paid": [
                  {
                    "year": 2021,
                    "month": 3,
                    "etv": 1000.816,
                    "count": 115
                  },
                  {
                    "year": 2021,
                    "month": 2,
                    "etv": 1018.3889999999999,
                    "count": 116
                  },
                  {
                    "year": 2021,
                    "month": 1,
                    "etv": 18974.175,
                    "count": 66
                  }
                ],
                "local_pack": null,
                "featured_snippet": null
              }
            },
            {
              "se_type": "google",
              "target": "dataforseo.com",
              "metrics": {
                "organic": [
                  {
                    "year": 2021,
                    "month": 3,
                    "etv": 2105.9753199999996,
                    "count": 2182
                  },
                  {
                    "year": 2021,
                    "month": 2,
                    "etv": 2040.1312899999996,
                    "count": 2116
                  },
                  {
                    "year": 2021,
                    "month": 1,
                    "etv": 857.4093259999999,
                    "count": 977
                  }
                ],
                "paid": [
                  {
                    "year": 2021,
                    "month": 3,
                    "etv": 18.546,
                    "count": 16
                  },
                  {
                    "year": 2021,
                    "month": 2,
                    "etv": 16.689,
                    "count": 14
                  },
                  {
                    "year": 2021,
                    "month": 1,
                    "etv": 13.851000000000003,
                    "count": 11
                  }
                ],
                "local_pack": null,
                "featured_snippet": null
              }
            },
            {
              "se_type": "google",
              "target": "forbes.com",
              "metrics": {
                "organic": [
                  {
                    "year": 2021,
                    "month": 3,
                    "etv": 131010988.8173943,
                    "count": 20272197
                  },
                  {
                    "year": 2021,
                    "month": 2,
                    "etv": 135602781.92437834,
                    "count": 19880946
                  },
                  {
                    "year": 2021,
                    "month": 1,
                    "etv": 75523208.1699421,
                    "count": 11178002
                  }
                ],
                "paid": [
                  {
                    "year": 2021,
                    "month": 3,
                    "etv": 754.279,
                    "count": 335
                  },
                  {
                    "year": 2021,
                    "month": 2,
                    "etv": 468.22399999999993,
                    "count": 160
                  },
                  {
                    "year": 2021,
                    "month": 1,
                    "etv": 17974.392,
                    "count": 154
                  }
                ],
                "local_pack": null,
                "featured_snippet": null
              }
            }
          ]
        }
      ]
    }
  ]
}